#define NULLCHAR 0
#define TC 0
#define NC 1
#define BC 2
#define MC 3
#define RAW_INPUT_WIDTH 1024
#define CR 13
#define HT 9
#define LF 10
#define BACKSLASH 92
#define NN 1024
#define PRIM 1
#define GPRIME 929
#define KK 32
#define A0 928
#define Ldec 1
#define MAX_LINE   1024         // longest input line allowed

#ifndef WIN32
#define DO_GIFS
#endif

typedef int Int32;
typedef unsigned int UInt32;
typedef unsigned long UInt64;
typedef short Int16;

int raw_bits[256][1024];        // raw output of bits
char raw_input[64][RAW_INPUT_WIDTH];    // raw lines of input
int raw_lines;                  // count of number of raw lines of input

int Alpha_to[1024];
int Index_of[1024];

int digit_table_valid;
char opstring[MAX_LINE];
int row;
char quotchar;
int digit_vals[50][16];         /* base 900 values for 1, 10, 100, 1000 .. 10^45 */


int end_of_file;
int linenum;                    /* line of input file */
int linechar;                   /* index to char in input line */
char inline_str[MAX_LINE];

int eras_pos[128];              /* erasure positions, for ecc testing */
int no_eras;

char *input_filename;
char *output_filename;

FILE *infile1;

#define TRUE 1
#define FALSE 0
#define PDF417_START 0x1fea8
#define PDF417_STOP  0x1fd14

Int32 *out;

int mods[100][100];
int powers_of_3[1024];
int log_of_3[1024];

int erase_posit[2048];          /* used to indicate erasures */

int synd_array[2048];

int global;


UInt32 data[3000];              /* this is the array of data, ecc will be added */
                          /* this will be x rows of y columns where */
                          /* y = number_of_columns - 2; */


UInt32 rows_columns[90][32];    /* rectangle of rows, columns */
                                /* max 90 rows, max 32 columns */

int number_of_rows;
int number_of_columns;          /* number of total columns = left, data, right */
int ec_level;
int eclen;                      /* number of bytes in ecc */

int codeindex;
int mcb_start;
int mcb_end;
int codes[3000];                /* put_back array */
